package com.matejdr.brightcoveimaplayer.util;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.widget.ImageView;

import java.net.HttpURLConnection;
import java.net.URL;

public class ImageLoader extends AsyncTask<String, Void, Bitmap> {
  private final ImageView imageView;

  public ImageLoader(ImageView imageView) {
    this.imageView = imageView;
  }

  @Override
  protected Bitmap doInBackground(String... params) {
    HttpURLConnection connection = null;
    try {
      URL url = new URL(params[0]);
      connection = (HttpURLConnection) url.openConnection();
      connection.connect();
      if (connection.getResponseCode() == HttpURLConnection.HTTP_OK) {
        return BitmapFactory.decodeStream(connection.getInputStream());
      }
      return null;
    } catch (Exception e) {
      e.printStackTrace();
    } finally {
      if (connection != null) {
        connection.disconnect();
      }
    }
    return null;
  }

  protected void onPostExecute(Bitmap result) {
    if (result == null) {
      this.imageView.setImageResource(android.R.color.transparent);
    } else {
      this.imageView.setImageBitmap(result);
    }
  }
}
