function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import React, { Component } from 'react';
import { requireNativeComponent, UIManager, Platform, findNodeHandle } from 'react-native';
const LINKING_ERROR = `The package 'react-native-brightcove-ima-player' doesn't seem to be linked. Make sure: \n\n` + Platform.select({
  ios: "- You have run 'pod install'\n",
  default: ''
}) + '- You rebuilt the app after installing the package\n' + '- You are not using Expo managed workflow\n';
const ComponentName = 'BrightcoveIMAPlayerView';
const BrightcoveIMAPlayerView = UIManager.getViewManagerConfig(ComponentName) != null ? requireNativeComponent(ComponentName) : () => {
  throw new Error(LINKING_ERROR);
};
export class BrightcoveIMAPlayer extends Component {
  constructor(...args) {
    super(...args);
    _defineProperty(this, "componentWillUnmount", () => {
      if (Platform.OS === 'ios') {
        UIManager.dispatchViewManagerCommand(findNodeHandle(this), UIManager.getViewManagerConfig(ComponentName).Commands.dispose, []);
      }
    });
    _defineProperty(this, "seekTo", seconds => {
      UIManager.dispatchViewManagerCommand(findNodeHandle(this), UIManager.getViewManagerConfig(ComponentName).Commands.seekTo, [seconds]);
    });
    _defineProperty(this, "toggleFullscreen", isFullscreen => {
      UIManager.dispatchViewManagerCommand(findNodeHandle(this), UIManager.getViewManagerConfig(ComponentName).Commands.toggleFullscreen, [isFullscreen]);
    });
    _defineProperty(this, "toggleInViewPort", inViewPort => {
      UIManager.dispatchViewManagerCommand(findNodeHandle(this), UIManager.getViewManagerConfig(ComponentName).Commands.toggleInViewPort, [inViewPort]);
    });
    _defineProperty(this, "stopPlayback", () => {
      UIManager.dispatchViewManagerCommand(findNodeHandle(this), UIManager.getViewManagerConfig(ComponentName).Commands.stopPlayback, []);
    });
    _defineProperty(this, "play", () => {
      UIManager.dispatchViewManagerCommand(findNodeHandle(this), UIManager.getViewManagerConfig(ComponentName).Commands.play, []);
    });
    _defineProperty(this, "pause", () => {
      UIManager.dispatchViewManagerCommand(findNodeHandle(this), UIManager.getViewManagerConfig(ComponentName).Commands.pause, []);
    });
  } // private _root: React.RefObject<BrightcoveIMAPlayer> = React.createRef();
  render() {
    return /*#__PURE__*/React.createElement(BrightcoveIMAPlayerView
    // ref={(e: React.RefObject<BrightcoveIMAPlayer>) => (this._root = e)}
    , this.props);
  }
}
//# sourceMappingURL=BrightcoveIMAPlayer.js.map