import { Component } from 'react';
import { ViewProps, NativeSyntheticEvent } from 'react-native';
declare type TBrightcoveIMAPlayerSettings = {
    IMAUrl: string;
    autoAdvance?: boolean;
    autoPlay?: boolean;
    allowsExternalPlayback?: boolean;
    publisherProvidedID?: string;
};
declare type TBrightcoveIMAPlayerEventBase = {
    target: number;
};
declare type TBrightcoveIMAPlayerEventProgress = TBrightcoveIMAPlayerEventBase & {
    currentTime: number;
};
declare type TBrightcoveIMAPlayerEventDuration = TBrightcoveIMAPlayerEventBase & {
    duration: number;
};
declare type TBrightcoveIMAPlayerEventBuffer = TBrightcoveIMAPlayerEventBase & {
    bufferProgress: number;
};
declare type BrightcoveIMAPlayerProps = ViewProps & {
    accountId: string;
    policyKey: string;
    playerName: string;
    videoId: string;
    settings: TBrightcoveIMAPlayerSettings;
    autoPlay?: boolean;
    play?: boolean;
    fullscreen?: boolean;
    disableDefaultControl?: boolean;
    volume?: number;
    bitRate?: number;
    /**
     * Ad Video Load Timeout in milliseconds, default is 3000.
     */
    adVideoLoadTimeout?: number;
    playbackRate?: number;
    onAdsLoaded?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
    onReady?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
    onPlay?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
    onPause?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
    onEnd?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
    onProgress?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventProgress>) => void;
    onAdsPlaying?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
    onChangeDuration?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventDuration>) => void;
    onUpdateBufferProgress?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBuffer>) => void;
    onEnterFullscreen?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
    onExitFullscreen?: (event: NativeSyntheticEvent<TBrightcoveIMAPlayerEventBase>) => void;
};
export declare class BrightcoveIMAPlayer extends Component<BrightcoveIMAPlayerProps> {
    componentWillUnmount: () => void;
    seekTo: (seconds: number) => void;
    toggleFullscreen: (isFullscreen: boolean) => void;
    toggleInViewPort: (inViewPort: boolean) => void;
    stopPlayback: () => void;
    play: () => void;
    pause: () => void;
    render(): JSX.Element;
}
export {};
